import string
import sys
import csv
import pandas as pd
import math
import numpy as np

''' 1. READ '''
xls = pd.ExcelFile('WeatherData.xlsx') #initialize pandas excel reader
Table1 = xls.parse('Table1') #this is now a pandas data frame; pandas operations apply
Table2 = xls.parse('Table2')
Table3 = xls.parse('Table3')

print Table1[:4]

''' 2. TRANSFORM '''
Days = Table1.copy(deep=True) #make a copy of the list of days
Days = Days[['Day']] #Drop all columns from this new DF except 'Day'

Temps = Table2[(Table2['Measure'] == 'Temp')] #get all rows from Table2 where Measure is Temp
Temps = Temps[['Day','Value']] #just keep Day and Value - don't need Measure any more
Temps.columns = ['Day', 'Temp'] #rename Value to 'Temp'
  
Humids = Table2[(Table2['Measure'] == 'Humidity')]
Humids = Humids[['Day','Value']]
Humids.columns = ['Day', 'Humidity']

NewTable2 = pd.merge(Days, Temps, how='left', on='Day') #Left merge Temps on Days
NewTable2 = pd.merge(NewTable2, Humids, how='left', on='Day') #Left merge Humids on NewTable2

''' 3. CONSOLIDATE '''
Table1n2 = pd.merge(Table1, NewTable2, how='outer', on='Day') #bring Table1 and NewTable2 together
allData = pd.merge(Table1n2, Table3, how='outer', on='Day') #bring Table3 together with the others

''' 4/5. ALTER/SYNTHETIC '''
'''Note: this should have been done as an Alter, but you need Synthetic for the class exercises, so I've done it as if it's synthetic'''
Rule45=lambda row: 'True' if (row['PlayTime']>45) else 'False' #define the rule to be applied to each row
allData.insert(1, 'Play45+?', allData.apply(Rule45,axis=1)) #insert the new binary 'Play45+?' column according to rule above
allData.drop('PlayTime',axis=1,inplace=True) #drop the 'PlayTime' column
  
''' PRINT OUT DW '''
allData.to_csv('WeatherDataWarehouse.csv',index=False) #index=False prevents the row index from being saved